import { TeleBot } from "../src";
import Logger from "./logger";
import { TeleBotLog } from "../src/telebot/logger";

const ADMIN_ID = "489945380";
const EMOJIS = ["😂", "🌟", "❤️", "🍊", "🙈", "😌", "😁", "🤔", "😊", "😉", "🙂", "🙃"];

const bot = new TeleBot({
    token: "73107572:AAHAUu_kJVcFBqhxIwkY73_MT6i4quMXSr0",
    log: {
        // ids: [LID.TelegramMethod, LID.TelegramRequest],
        // levels: [Levels.error],
        logger(log: TeleBotLog) {
            Logger.log(
                log.level,
                [log.id, log.error ? log.error?.stack || log.error : log.message || log.meta].filter(i => !!i).join(" - ")
            );
        }
    }
});

const userList: Record<number, { timeout: boolean, lastDate: number }> = {};

// bot.mod("message", (payload) => {
//     let newPayload = payload as Message;
//     const messageDate = newPayload.date;
//     const id = newPayload.chat.id;
//     const user = userList[id];
//
//     const interval = 1;
//     const chillTime = 5;
//
//     if (user) {
//
//         const diff = messageDate - user.lastDate;
//         user.lastDate = messageDate;
//
//         // console.log(messageDate, user.lastDate, "=", diff, interval);
//
//         if (diff <= interval) {
//             if (!user.timeout) {
//                 bot.sendMessage(id, `You have been time out for ${chillTime} seconds.`);
//                 user.timeout = true;
//             }
//             // @ts-ignore
//             newPayload = null;
//         } else {
//             user.timeout = false;
//         }
//
//     } else {
//         userList[id] = { timeout: false, lastDate: messageDate };
//     }
//
//     return newPayload;
// });

function sleep(ms: number) {
    return new Promise(resolve => setTimeout(resolve, ms));
}

// bot.on("message", (msg) => {
//     return bot.forwardMessage(msg.chat.id, msg.chat.id, msg.message_id);
// });

// bot.on(["text", "photo"], (msg) => {
//     return bot.sendMessage(msg.chat.id, msg.text);
// });

bot.hears("hello", (msg, ctx) => {
    return bot.sendMessage(msg.chat.id, `Oh, hello ${msg.from?.first_name}!`);
});

bot.hears([/^\/(?<command>[\w\d]+)$/, "/start"], (msg, ctx) => {
// bot.hears(["/hello", "/start"], (msg, ctx) => {
    console.log(".");
    const command = ctx.match;
    // return bot.sendMessage("000", `Some kind of <b>${command}</b> command.`, { parse_mode: "html" });
    // return Promise.reject("LUUUL");
});

// bot.on("text", (msg, ctx) => {
//     console.log(".");
// });

// bot.on("text", (msg) => {
//     return bot.sendMessage(msg.chat.id, msg.text);
// });

// bot.mod("sendMessage", (meta, context) => {
//     const randomEmoji = EMOJIS[Math.floor((Math.random() * EMOJIS.length))];
//     meta.required.text = `${randomEmoji} ${meta.required.text}`;
//     return meta;
// });

// bot.mod("sendMessage", async ([chatId, text], context) => {
//     const randomEmoji = EMOJIS[Math.floor((Math.random() * EMOJIS.length))];
//     // meta
//     // meta.required.text = `${meta.required.text} ${randomEmoji}`;
//     await sleep(2000);
//     return meta;
// });

bot.mod("text", (meta) => {
    meta.text = `<${meta.from.id}> ${meta.text}`;
    return meta;
});

bot.on("text", (msg) => {
    return bot.sendMessage(msg.chat.id, msg.text);
});

bot.hears("/id", (msg) => {
    if (msg.chat.type === "private") {
        return bot.sendMessage(msg.chat.id, `Your user id: <b>${msg.from!.id}</b>`, {
            parse_mode: "html"
        });
    }
});

function safeString(value: string) {
    return String(value).replace(/&/g, "&amp;")
        .replace(/</g, "&lt;")
        .replace(/>/g, "&gt;")
        .replace(/"/g, "&quot;");
}

bot.on("error", (error, ctx) => {
    let [payload, request, response] = ["", "", ""];
    const { name, message, stack } = error;
    const { methodName } = ctx || {};

    if ("payload" in error) payload = JSON.stringify(error.payload);
    if ("request" in error) request = JSON.stringify(error.request);
    if ("response" in error) response = JSON.stringify(error.response);

    // return Promise.reject("HO NO NO NO");

    // console.log("------------CTX", error, ctx);

    return bot.sendMessage(
        ADMIN_ID,
        [
            `⚠️ <b>${name}:</b> ${message}`,
            methodName && `✉️️ <b>Method:</b> ${methodName}`,
            `🚧 <b>Stacktrace:</b>\n\n<code>${safeString(stack || "")}</code>`,
            payload && `🚚️ <b>Payload:</b>\n\n<code>${payload}</code>`,
            request && `➡️ <b>Request:</b>\n\n<code>${request}</code>`,
            response && `⬅️ <b>Response:</b>\n\n<code>${response}</code>`
        ].filter(i => !!i).join("\n\n"),
        {
            parse_mode: "html"
        });
});

bot.start();
