import winston from "winston";

winston.addColors({
    error: "red",
    warn: "yellow",
    log: "green",
    http: "magenta",
    info: "cyan",
    debug: "gray"
});

const Logger = winston.createLogger({
    levels: {
        error: 0,
        warn: 1,
        // log: 2,
        http: 3,
        info: 4,
        debug: 5
    },
    level: "debug",
    format: winston.format.combine(
        winston.format.timestamp({ format: "YYYY-MM-DD HH:mm:ss:ms" }),
        winston.format.colorize({ all: true }),
        winston.format.printf(
            (info) => `${info.timestamp} ${info.level}: ${info.message}`
        )
    ),
    transports: [
        new winston.transports.Console()
    ]
});

export default Logger;
