import { TeleBot } from "../src";
import { Levels, TeleBotLog } from "../src/telebot/logger";
import Logger from "./logger";
import { TeleBotPlugin } from "../src/types/telebot";

const bot = new TeleBot({
    token: "73107572:AAHAUu_kJVcFBqhxIwkY73_MT6i4quMXSr0",
    log: {
        levels: [Levels.info, Levels.http, Levels.log, Levels.warn, Levels.error],
        logger(log: TeleBotLog) {
            Logger.log(
                log.level,
                [log.id, log.error ? log.error?.stack || log.error : log.message || log.meta]
                    .filter(i => !!i)
                    .join(" - ")
            );
        }
    }
});

type MyPluginContext = {
    command: string;
};

const myFirstPlugin: TeleBotPlugin<MyPluginContext> = {
    id: "my-first-plugin",
    name: "My First Plugin",
    version: "1.0.0",
    description: "My first TeleBot plugin!",
    author: "My Name <name@mail.local>",
    homepage: "https://mywebsite.local",
    plugin(bot: TeleBot, ctx) {
        bot.hears(ctx.command, (msg) => {
            return bot.sendMessage(msg.chat.id, `Echo: <i>${msg.text}</i>`, { parse_mode: "html" });
        });
    }
};

bot.plugin(myFirstPlugin, {
    command: "hi"
});

function readableDate(date: number) {
    return new Date(date * 1000).toISOString().replace(/T/, " ").replace(/\..+/, "");
}


bot.on("text", (msg) => {
    return bot.sendMessage(
        msg.chat.id,
        `🗣 <b>${msg.text}</b>\n\n🕓 <i>${readableDate(msg.date)}</i>`,
        {
            parse_mode: "html"
        }
    );
});

bot.start();

