import { TeleBot } from "../src";
import {TeleBotLog} from "../src/telebot/logger";
import Logger from "./logger";

const bot = new TeleBot({
    token: "73107572:AAHAUu_kJVcFBqhxIwkY73_MT6i4quMXSr0",
    log: {
        // ids: [LID.TelegramMethod, LID.TelegramRequest],
        // levels: [Levels.error],
        logger(log: TeleBotLog) {
            Logger.log(
                log.level,
                [log.id, log.error ? log.error?.stack || log.error : log.message || log.meta].filter(i => !!i).join(" - ")
            );
        }
    }
});


bot.hears(/\/donate\s(?<amount>[\d\\.,]+)$/, (msg, ctx) => {
    const { amount } = ctx.match.groups || {};

    let value = Number.parseInt(amount);
    const s = amount.split(/\.|,/);

    if (s.length > 1) {
        value = (Number.parseInt(s[0]) * 100) + Number.parseInt(s[1].slice(0, 2).padEnd(2, "0"));
    } else {
        value *= 100;
    }

    return bot.sendInvoice(msg.chat.id, {
        title: "Donation",
        description: "Your donation will be transferred to TeleBot creator - @mullwar",
        payload: `donation:${amount}`,
        provider_token: "410694247:TEST:3d37f1f0-4c51-4348-a17a-e777cbba9834",
        start_parameter: "donation",
        currency: "EUR",
        prices: [
            {
                label: "Donation",
                amount: value
            }
        ]
    }).catch((error) => {
        console.log("error", error);
        bot.sendMessage(msg.chat.id, "Sorry, something wrong! Please try later...");
        return Promise.reject(error);
    });
});

bot.on("pre_checkout_query", (msg) => {
    return bot.answerPreCheckoutQuery(msg.id, true);
});

bot.on("shipping_query", (msg) => {
    return bot.answerShippingQuery(msg.id, true);
});

bot.on("successful_payment", (msg) => {
    return bot.sendMessage(msg.chat.id, "Thank you for your donation!");
});

bot.start();
